<?php
/*
OekakiPoteto 5.x Copyright 2000-2002 RanmaGuy (Theo Chakkapark, http://suteki.nu) and Marcello Basta-Forte (http://marcello.cellosoft.com). Modification to the files are permitted as long as my name remains on the files.

Wacintaki Poteto modifications Copyright 2004-2006 Marc "Waccoon" Leveille, http://www.NineChime.com/products/
Version 1.3.0 - Last modified 5/1/2006
*/


define ('BOOT', 1);
$cfg = array();

// Debug prevents deletion of work files
$debug = 0;


// Custom installer functions
function make_new_file($path, $data = '') {
	if (file_exists ($path)) {
		return TRUE;
	}
	$fp = @fopen ($path, 'w');
	if (!$fp) {
		web_line('Could not create file &ldquo;'.$path.'&rdquo');
		return FALSE;
	}
	if (!empty ($data)) {
		fwrite ($fp, $data, strlen ($data));
	}
	fclose ($fp);
	return TRUE;
}


// Begin installer
include('common.php');
include('language/english.php');


// *** BEGIN HTML ***
echo <<<EOF
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
	<title>$langop_install_title</title>

	<meta http-equiv="Content-Type" content="text/html; charset=$charset">

	<link rel="stylesheet" type="text/css" href="templates/Install.css" title="Installer">
</head>
<body>


EOF;


// Startup tests
$errs = array();
if (!is_writable('.')) {
	$errs[] = "You need to CHMOD your main directory so it is writable (use 777 if you are not sure what to use).";
}
if (!is_writable('./templates')) {
	$errs[] = "You need to CHMOD the templates directory so it is writable (use 777 if you are not sure what to use).";
}
if (file_exists ('./resource') && (!is_writable ('./resource'))) {
	$errs[] = "The resource folder is present but not writable.  CHMOD it so it is writable (use 777 if you are not sure what to use).";
}
if (file_exists ('./pictures') && (!is_writable ('./pictures'))) {
	$errs[] = "The pictures folder is present but not writable.  CHMOD it so it is writable (use 777 if you are not sure what to use).";
}
if (file_exists ('./avatars') && (!is_writable ('./avatars'))) {
	$errs[] = "The avatars folder is present but not writable.  CHMOD it so it is writable (use 777 if you are not sure what to use).";
}
if (file_exists ('config.php') && (!is_writable ('config.php'))) {
	$errs[] = "The config file is not writable.  CHMOD it as defined in &ldquo;readme.html&rdquo; or delete the file if you are re-installing the board.";
}
if (file_exists ('dbconn.php') && (!is_writable ('dbconn.php'))) {
	$errs[] = "The database config file is not writable.  CHMOD it as defined in &ldquo;readme.html&rdquo; or delete the file if you are re-installing the board.";
}
$errs_count = count ($errs);
if ($errs_count > 0) {
	for ($i = 0; $i < $errs_count; $i++) {
		echo ("<p>{$errs[$i]}</p>\n\n");
	}
echo <<<EOF
</body>
</html>
EOF;
//<?
	exit;
}


// Confirmation for delete database
if ($_GET['mode'] == 'del') {
echo <<<EOF
	<h1 class="title">
		Delete database
	</h1>

	<hr />



EOF;
//<?

	if (file_not_empty('dbconn.php') && file_not_empty('config.php')) {
		include('config.php');

		if (empty ($cfg['op_title'])) {
			$cfg['op_title'] = '[ Unnamed, Data Prefix="'.$OekakiPoteto_Prefix.'", Member Prefix="'.$OekakiPoteto_MemberPrefix.'" ]';
		}

echo <<<EOF
	<h2 class="header">
		Uninstall the OekakiPoteto database?
	</h2>

	<div class="infotable">
		<p class="infonote">
			Are you sure you want to remove the database?  This will remove information for the board "{$cfg['op_title']}".  Images, templates, and all other files in the OP directory must be deleted manually.<br />
			<br />
			If you have only one board, you may delete both databases below.<br />
			<br />
			If you are sharing a database with more than one board, be sure to delete <em>only</em> the database for posts and comments.  If you delete the database for member profiles, all your boards will cease to function!<br />
			<br />
			Each board must be removed with its respective installer.
		</p>

		<form action="install.php" method="post" class="infonote">
			<input name="action" type="hidden" value="db_delete" />

			<input name="db_prefix" type="checkbox" />Delete posts and comments.<br />
			<input name="db_members" type="checkbox" />Delete member profiles, chat, and mailboxes.<br />
			<br />
			<input name="submit" type="submit" value="Delete" />
		</form>
	</div>
</body>
</html>
EOF;
//<?

		exit;

	} else {

echo <<<EOF
	<h2 class="header">
		Uninstall error
	</h2>

	<div class="infotable">
		<p class="infonote">
			Valid database and config files were not found.  The board must be properly installed before any database entries can be removed.  If problems persist, let your sysadmin delete the databases by name.
		</p>
	</div>
</body>
</html>
EOF;
//<?

		exit;
	}
}


// Delete database
//
if ($_POST['action'] == 'db_delete') {
	include('dbconn.php');
	include('config.php');
	$delete_flag = 0;

echo <<<EOF
	<h1 class="title">
		Delete database
	</h1>

	<hr />


	<h2 class="header">
		Uninstall Status
	</h2>

	<div class="infotable">
		<p>

EOF;
//<?

	if ($_POST['db_prefix'] != '' && !$debug) {
		$result = mysql_query ("DROP TABLE {$OekakiPoteto_Prefix}oekakicmt");
		sql_check($result);
		$result = mysql_query ("DROP TABLE {$OekakiPoteto_Prefix}oekakidta");
		sql_check($result);
		$result = mysql_query ("DROP TABLE {$OekakiPoteto_Prefix}oekakimisc");
		sql_check($result);

		$delete_flag = 1;
	}

	if ($_POST['db_members'] != '' && !$debug) {
		$result = mysql_query ("DROP TABLE {$OekakiPoteto_MemberPrefix}oekaki");
		sql_check($result);
		$result = mysql_query ("DROP TABLE {$OekakiPoteto_MemberPrefix}oekakichat");
		sql_check($result);
		$result = mysql_query ("DROP TABLE {$OekakiPoteto_MemberPrefix}oekakichatmod");
		sql_check($result);
		$result = mysql_query ("DROP TABLE {$OekakiPoteto_MemberPrefix}oekakichatmodusers");
		sql_check($result);
		$result = mysql_query ("DROP TABLE {$OekakiPoteto_MemberPrefix}oekakionline");
		sql_check($result);
		$result = mysql_query ("DROP TABLE {$OekakiPoteto_MemberPrefix}oekakikill");
		sql_check($result);
		$result = mysql_query ("DROP TABLE {$OekakiPoteto_MemberPrefix}oekakimailbox");
		sql_check($result);

		$delete_flag = 1;
	}

	mysql_close($dbconn);
?>
		</p>

<? if ($delete_flag == 1) { ?>
		<p>
			<?=$langop_install_dbremove?> 
		</p>
<? } else { ?>
		<p>
			NOTE:  No databases changed
		</p>
<? } ?>

		<p>
			<a href="install.php">Return to the installer</a>
		</p>
	</div>

</body>
</html>
<?
	exit;
}


//
// User submits information (Yes, this is different from the control panel)
if ($_POST['Submit'] == 'Submit') {

	// Check all posts
	foreach ($_POST as $key=>$value) {
		$_POST[$key] = trim (slashit ($_POST[$key]));
	}


echo <<<EOF
	<h1 class="title">
		Wacintaki Poteto Installation
	</h1>

	<hr />


	<h2 class="header">
		Installation Progress
	</h2>

	<div class="infotable">
		<p>

EOF;
//<?


	// Verify input
	$OekakiPoteto_Prefix = $_POST['dbprefix'];
	$OekakiPoteto_MemberPrefix = $_POST['OekakiPoteto_MemberPrefix'];
	$pass    = $_POST['pass'];
	$pass2   = $_POST['pass2'];
	$salt    = $_POST['salt'];
	$usrname = $_POST['usrname'];

	$input_fail = 0;
	if (empty ($_POST['dbhost']) || empty ($_POST['dbuser']) || empty ($_POST['dbname'])) {
		web_line('ERROR:  Your database settings are invalid.');
		$input_fail = 1;
	}
	if (empty ($_POST['dbpass'])) {
		web_line('NOTE:  Database password is blank (not an error).');
	}
	if (empty ($usrname)) {
		web_line('ERROR:  The administrator login name is missing.');
		$input_fail = 1;
	}
	if (empty ($pass) || empty ($pass2)) {
		web_line('ERROR:  The administrator password is missing.');
		$input_fail = 1;
	}
	if ($pass != $pass2) {
		web_line('ERROR:  The administrator passwords do not match.');
		$input_fail = 1;
	}
	if (empty ($salt)) {
		$salt = 'As';
	}
	if ($input_fail == 1) {
echo <<<EOF
		</p>
	</div>
</body>
</html>
EOF;
		exit;
	}
	web_line();


// Create a database connection file from POST data.
$db_configuration = <<<EOF
<?php // Include only

	\$dbhost = '{$_POST['dbhost']}';
	\$dbuser = '{$_POST['dbuser']}';
	\$dbpass = '{$_POST['dbpass']}';
	\$dbname = '{$_POST['dbname']}';
	\$OekakiPoteto_Prefix = '{$_POST['dbprefix']}';
	\$OekakiPoteto_MemberPrefix = '{$_POST['OekakiPoteto_MemberPrefix']}';

	\$dbconn = mysql_connect(\$dbhost, \$dbuser, \$dbpass) or die('Could not connect to the MySQL database.');
	\$mySQLDB = mysql_select_db(\$dbname);

?>
EOF;
//<?

	// Create a configuration file from POST data.
	// Verify paths
	$op_url  = strip_path($_POST['op_url']);
	$op_pics = strip_path($_POST['op_pics']);
	$avatar_folder = strip_path($_POST['avatar_folder']);

	if (empty ($op_pics)) {
		$op_pics = 'pictures';
	}
	if (empty ($avatar_folder)) {
		$avatar_folder = 'avatars';
	}
	$_POST['op_pre']   = strip_path($_POST['op_pre']);
	$_POST['preview_img'] = strip_path($_POST['preview_img']);
	$_POST['porn_img']    = strip_path($_POST['porn_img']);

	// #@!*'n magic quotes!
	$the_title = str_replace('\\"', '&quot;', $_POST['op_title']);
	$the_author = str_replace('\\"', '&quot;', $_POST['op_author']);
	$the_preview = str_replace('\\"', '&quot;', $_POST['preview_title']);

	// Other verification
	$reg_draw   = 'no';
	$reg_anim   = 'no';
	$reg_upload = 'no';
	if (!empty ($_POST['reg_draw']))   $reg_draw = 'yes';
	if (!empty ($_POST['reg_anim']))   $reg_anim = 'yes';
	if (!empty ($_POST['reg_upload'])) $reg_upload = 'yes';

	// Fix e-mails
	$op_email = trim ($_POST['op_email']);
	$admin_email = trim ($_POST['admin_email']);
	if (empty ($admin_email)) {
		$admin_email = $op_email;
	}

	// Other verification
	$reg_draw   = 'no';
	$reg_anim   = 'no';
	$reg_upload = 'no';
	if (!empty ($_POST['reg_draw']))   $reg_draw = 'yes';
	if (!empty ($_POST['reg_anim']))   $reg_anim = 'yes';
	if (!empty ($_POST['reg_upload'])) $reg_upload = 'yes';

	// Verify min/max values
	{
		$verify     = array ('pic_store', 'pic_pages', 'menu_pages', 'def_x', 'def_y', 'canvas_x', 'canvas_y', 'min_x', 'min_y', 'canvas_a', 'max_anim', 'thumb_bytes', 'thumb_t', 'thumb_r', 'max_pic', 'avatar_x', 'avatar_y', 'safety_storetime');
		$verify_min = array (10, 1, 5, 50, 50, 50, 50, 50, 50, 2500, 1000, 25000, 50, 50, 100000, 1, 1, 1);
		$verify_max = array (10000, 50, 500, 10000, 10000, 10000, 10000, 500, 500, 100000000, 1000000, 15000000, 500, 1000, 2000000, 150, 150, 100);

		$i = 0;
		foreach ($verify as $name) {
			if ($_POST[$name] < $verify_min[$i]) $_POST[$name] = $verify_min[$i];
			if ($_POST[$name] > $verify_max[$i]) $_POST[$name] = $verify_max[$i];
			$i++;
		}
	}

	$main_configuration = <<<EOF
<?php // Include only
	\$cfg = array();
	\$cfg['version'] = '1.3.0';

	\$cfg['op_title']  = '$the_title';
	\$cfg['op_author'] = '$the_author';
	\$cfg['op_adult']  = '{$_POST['op_adult']}';
	\$cfg['op_email']  = '{$op_email}';
	\$cfg['op_url']    = '{$op_url}';

	\$cfg['salt']    = '{$salt}';
	\$cfg['op_pics'] = '{$op_pics}';
	\$cfg['op_pre']  = '{$_POST['op_pre']}';

	\$cfg['kill_user']   = '{$_POST['kill_user']}';
	\$cfg['kill_reg']    = '15';
	\$cfg['draw_immune'] = '{$_POST['draw_immune']}';
	\$cfg['approval']    = '{$_POST['approval']}';
	\$cfg['require_art'] = '{$_POST['require_art']}';
	\$cfg['guest_post']  = '{$_POST['guest_post']}';
	\$cfg['guest_draw']  = 'no'; //WIP
	\$cfg['guest_adult'] = '{$_POST['guest_adult']}';
	\$cfg['reg_draw']    = '$reg_draw';
	\$cfg['reg_anim']    = '$reg_anim';
	\$cfg['reg_upload']  = '$reg_upload';
	\$cfg['reg_rules']   = '{$_POST['reg_rules']}';

	\$cfg['language'] = 'english';
	\$cfg['template'] = '{$_POST['template']}';
	\$cfg['tpl_path'] = 'templates';
	\$cfg['res_path'] = 'resource';

	\$cfg['pic_store']  = '{$_POST['pic_store']}';
	\$cfg['pic_pages']  = '{$_POST['pic_pages']}';
	\$cfg['menu_pages'] = '{$_POST['menu_pages']}';
	\$cfg['pic_limit']      = '2';  //WIP
	\$cfg['pic_limit_time'] = '24'; //WIP

	\$cfg['porn_img']      = '{$_POST['porn_img']}';
	\$cfg['preview_img']   = '{$_POST['preview_img']}';
	\$cfg['preview_title'] = '{$the_preview}';
	\$cfg['def_x']    = '{$_POST['def_x']}';
	\$cfg['def_y']    = '{$_POST['def_y']}';
	\$cfg['canvas_x'] = '{$_POST['canvas_x']}';
	\$cfg['canvas_y'] = '{$_POST['canvas_y']}';
	\$cfg['min_x']    = '{$_POST['min_x']}';
	\$cfg['min_y']    = '{$_POST['min_y']}';
	\$cfg['canvas_a'] = '{$_POST['canvas_a']}';
	\$cfg['max_anim'] = '{$_POST['max_anim']}';
	\$cfg['max_pic']  = '{$_POST['max_pic']}';

	\$cfg['use_thumb']   = '{$_POST['use_thumb']}';
	\$cfg['force_thumb'] = '{$_POST['force_thumb']}';
	\$cfg['thumb_bytes'] = '{$_POST['thumb_bytes']}';
	\$cfg['thumb_t']     = '{$_POST['thumb_t']}';
	\$cfg['thumb_r']     = '{$_POST['thumb_r']}';
	\$cfg['thumb_jpg']   = '75';

	\$cfg['use_mailbox'] = '{$_POST['use_mailbox']}';

	\$cfg['use_chat']   = '{$_POST['use_chat']}';
	\$cfg['chat_max']   = '{$_POST['chat_max']}';
	\$cfg['chat_pages'] = '{$_POST['chat_pages']}';

	\$cfg['smilies'] = '{$_POST['smilies']}';

	\$cfg['use_avatars']   = '{$_POST['use_avatars']}';
	\$cfg['use_c_avatars'] = '{$_POST['use_c_avatars']}';
	\$cfg['avatar_folder'] = '{$avatar_folder}';
	\$cfg['avatar_x'] = '{$_POST['avatar_x']}';
	\$cfg['avatar_y'] = '{$_POST['avatar_y']}';

	\$cfg['public_retouch']   = '{$_POST['public_retouch']}';
	\$cfg['safety_storetime'] = '{$_POST['safety_storetime']}';
	\$cfg['safety_saves']     = '{$_POST['safety_saves']}';
	\$cfg['self_bump']        = '{$_POST['self_bump']}';
?>
EOF;
//<?


	// Write the config files
	$fp = @fopen ('dbconn.php', 'w');
	if ($fp) {
		fwrite ($fp, $db_configuration);
		fclose ($fp);
		web_line('Wrote database config file...');
	} else {
		web_line('ERROR:  Could not open database config file for writing.  Check your server permissions');
echo <<<EOF
		</p>
	</div>
</body>
</html>
EOF;
//<?
		exit;
	}


	$fp = @fopen ('config.php', 'w');
	if ($fp) {
		fwrite ($fp, $main_configuration);
		fclose ($fp);
		web_line('Wrote config file...');
	} else {
echo <<<EOF
			ERROR:  Could not open config file for writing.  Check your server permissions.
		</p>
	</div>
</body>
</html>
EOF;
//<?
		exit;
	}

	web_line();


	/* Create specified directories with their respective permissions */
	if (! file_exists ($op_pics)) {
		if (! @mkdir ($op_pics, 0755)) {
			web_line('ERROR:  Could not create folder <em>'.$op_pics.'</em>');
		}
	}
	if (! is_writable ($op_pics)) {
		web_line('ERROR:  Folder <em>'.$op_pics.'</em> is locked.  You may have to create this folder manually.');
	}
	if (! file_exists ($avatar_folder)) {
		if (! @mkdir ($avatar_folder, 0755)) {
			web_line('ERROR:  Could not create folder <em>'.$avatar_folder.'</em>');
		}
	}
	if (! is_writable ($avatar_folder)) {
		web_line('ERROR:  Folder <em>'.$avatar_folder.'</em> is locked.  You may have to create this folder manually.');
	}


	/* Create base resource files */
	$new_files = array (
		'banner.php' => '',
		'hosts.txt' => '',
		'ips.txt' => '',
		'notice.php' => '',
		'rules.php' => "<p>\nNetiquette applies.  Ask the admin if you have any questions.\n</p>"
	);
	$nf_error = 0;
	foreach ($new_files as $file_name => $file_data) {
		$status = make_new_file('resource/'.$file_name, $file_data);
		if (!$status)
			$nf_error++;
	}
	if ($nf_error) {
echo <<<EOF
			One or more base files could not be created.  Try again or manually create the listed files with zero length.
		</p>
	</div>
</body>
</html>
EOF;
//<?
		exit;
	}

	web_line('Wrote base &ldquo;resource&rdquo; folder files...');
	web_line();


	/* Insert the fields into the database */
	web_line('Starting to set up database...');

	include('dbconn.php');
	include('config.php');

	$passenc = crypt($pass, $salt);

	if ($debug == 0) {
		{
			// Oekaki v1.0.0
			$sql = "CREATE TABLE IF NOT EXISTS `{$OekakiPoteto_MemberPrefix}oekaki` (ID int(11) NOT NULL auto_increment, usrname varchar(255) NOT NULL default '', usrpass text DEFAULT '', usrflags varchar(10) default 'G', email varchar(255) default NULL, name varchar(25) default NULL, comment text, url text, aim varchar(30) default NULL, icq varchar(20) default NULL, urltitle text, joindate date NOT NULL default '0000-00-00', lastlogin datetime NOT NULL default '0000-00-00 00:00:00', MSN text, Yahoo text, IRCNick text, IRCServer text, location text, piccount int(11) NOT NULL default '0', IRCchan text, templatesel varchar(255) NOT NULL DEFAULT '', commcount int(11) NOT NULL DEFAULT '0', age text, gender text, picview tinyint(11) NOT NULL default '0', language VARCHAR(32) DEFAULT '', ";

			// Oekaki v1.1.0
			$sql .= "thumbview TINYINT NOT NULL DEFAULT 0, screensize MEDIUMINT NOT NULL DEFAULT 800, ";

			// Oekaki v1.2.0
			$sql .= "rank TINYINT NOT NULL DEFAULT 0, ";

			// Oekaki v1.3.0
			$sql .= "avatar VARCHAR(128) NOT NULL DEFAULT '', ";

			// Set info
			$sql .= "PRIMARY KEY (ID), UNIQUE KEY usrname (usrname)) TYPE=MyISAM";
			$result = mysql_query ($sql);
			sql_check($result, 'members');
		}

		$sqlstr = "INSERT INTO {$OekakiPoteto_MemberPrefix}oekaki (usrname, usrpass, usrflags, email, name, comment, joindate, language, rank) VALUES ('$usrname', '$passenc', 'GDMIU', '{$admin_email}', 'Administrator', 'Administrator Account', CURDATE(), 'english', 9)";
		$result = mysql_query ($sqlstr);
		sql_check($result, 'admin');

		$result = mysql_query ("CREATE TABLE IF NOT EXISTS `{$OekakiPoteto_MemberPrefix}oekakichat` (ChatID int(11) NOT NULL auto_increment, usrname varchar(255) NOT NULL default '', comment tinytext NOT NULL DEFAULT '', posttime timestamp(14) NOT NULL, hostname text NOT NULL DEFAULT '', email varchar(255) default NULL, url text DEFAULT '', IP text NOT NULL DEFAULT '', postname varchar(50) NOT NULL default '', PRIMARY KEY  (ChatID)) TYPE=MyISAM");
		sql_check($result, 'chat');

		$result = mysql_query ("CREATE TABLE IF NOT EXISTS `{$OekakiPoteto_Prefix}oekakicmt` (ID_3 int(11) NOT NULL auto_increment, PIC_ID varchar(11) NOT NULL default '', usrname varchar(255) NOT NULL default '', comment text NOT NULL DEFAULT '', postdate datetime default NULL, hostname text NOT NULL DEFAULT '', email varchar(255) default NULL, url text DEFAULT '', IP text NOT NULL DEFAULT '', postname varchar(50) NOT NULL default '', PRIMARY KEY  (ID_3), KEY PIC_ID (PIC_ID)) TYPE=MyISAM"); 
		sql_check($result, 'comment');

		{
			// OekakiData v1.0.0
			$sql = "CREATE TABLE IF NOT EXISTS `{$OekakiPoteto_Prefix}oekakidta` (ID_2 int(11) NOT NULL auto_increment, PIC_ID int(11) NOT NULL default 0, usrname varchar(255) NOT NULL default '', comment text NOT NULL DEFAULT '', postdate datetime NOT NULL default '0000-00-00 00:00:00', hostname text NOT NULL DEFAULT '', email varchar(255) default NULL,  url text DEFAULT '', IP text NOT NULL DEFAULT '', title varchar(255) default NULL, lastcmt datetime NOT NULL default '0000-00-00 00:00:00', adult tinyint(2) NOT NULL default '0', edittime int(20) unsigned default NULL, animation tinyint(2) default '0', datatype tinyint(2) default '0', archive tinyint(2) NOT NULL default '0', postlock tinyint(4) NOT NULL default '0', ";

			// OekakiData v1.1.0
			$sql .= "threadlock TINYINT NOT NULL DEFAULT 0, px MEDIUMINT DEFAULT 0, py MEDIUMINT DEFAULT 0, ptype VARCHAR(4), ttype VARCHAR(4), rtype VARCHAR(4), usethumb TINYINT NOT NULL DEFAULT 0, ";

			// OekakiData v1.2.0
			$sql .= "password text NOT NULL DEFAULT '', ";

			// OekakiData v1.3.0
			$sql .= "origart VARCHAR(255) NOT NULL DEFAULT '', ";

			// Set info
			$sql .= "PRIMARY KEY (ID_2), UNIQUE KEY PIC_ID (PIC_ID)) TYPE=MyISAM";
			$result = mysql_query ($sql);
			sql_check($result, 'data');
		}

		$result = mysql_query ("CREATE TABLE IF NOT EXISTS `{$OekakiPoteto_MemberPrefix}oekakionline` (OID BIGINT(255) NOT NULL auto_increment, onlineusr varchar(100) NOT NULL default '', onlinetime timestamp(14) NOT NULL, onlineIP text NOT NULL DEFAULT '', locale varchar(30) default NULL, onlineboard text NOT NULL DEFAULT '', PRIMARY KEY  (OID), UNIQUE KEY onlineusr (onlineusr)) TYPE=MyISAM");
		sql_check($result, 'online');

		$result = mysql_query ("CREATE TABLE IF NOT EXISTS `{$OekakiPoteto_MemberPrefix}oekakimailbox` (MID int(11) NOT NULL auto_increment, sender varchar(255) NOT NULL default '', reciever varchar(255) NOT NULL default '', subject text NOT NULL DEFAULT '', body longtext NOT NULL DEFAULT '', mstatus smallint(10) NOT NULL default '0', senddate datetime NOT NULL default '0000-00-00 00:00:00', PRIMARY KEY (MID), KEY sender(sender), KEY reciever (reciever)) TYPE=MyISAM"); 
		sql_check($result, 'mailbox');

		$result = mysql_query ("CREATE TABLE IF NOT EXISTS `{$OekakiPoteto_Prefix}oekakimisc` (MiscID int(11) NOT NULL auto_increment, miscname varchar(255) NOT NULL default '', miscvalue bigint(255) default '0' NOT NULL, miscstring VARCHAR(14), PRIMARY KEY (MiscID), KEY miscname (miscname)) TYPE=MyISAM");
		sql_check($result, 'misc');

		$result = mysql_query ("CREATE TABLE IF NOT EXISTS `{$OekakiPoteto_MemberPrefix}oekakichatmod` (usrname varchar(255) NOT NULL default '',  command varchar(32) NOT NULL default 'MESSAGE', comment tinytext NOT NULL DEFAULT '', posttime timestamp(14) NOT NULL, hostname text NOT NULL DEFAULT '', email varchar(255) default NULL, url text DEFAULT '',  IP text NOT NULL DEFAULT '', postname varchar(50) NOT NULL default '', PRIMARY KEY (posttime)) TYPE=MyISAM"); 
		sql_check($result, 'chat_mod');

		$result = mysql_query ("CREATE TABLE IF NOT EXISTS `{$OekakiPoteto_MemberPrefix}oekakichatmodusers` (usrname varchar(255) NOT NULL,  lastmessage timestamp(14) NOT NULL, afk ENUM('no','yes') NOT NULL default 'no', PRIMARY KEY (usrname)) TYPE=MyISAM");
		sql_check($result, 'chat_mod_users');

		$result = mysql_query ("INSERT INTO {$OekakiPoteto_Prefix}oekakimisc VALUES (1, 'piccount', 0, NULL)");
		sql_check($result, 'piccount');
		$result = mysql_query ("INSERT INTO {$OekakiPoteto_Prefix}oekakimisc VALUES (2, 'dbversion', 0, '1.3.0')");
		sql_check($result, 'dbversion');
	}

	mysql_close ($dbconn);

	web_line('Finished setting up database...');

echo <<<EOF
		</p>
		<hr />

		<p class="infonote">
			If you did not recieve any errors, the databases have been installed.<br />
			<br />
			If you are installing another board and your primary board is functioning properly, ignore any database errors.<br />
			<br />
			Click the button below to finalize the installation.  This will clean up the installer files and prevent security problems.  You will have to copy <em>install.php</em> into the Oekaki Poteto folder if you need to uninstall the database.  All other maintenance can be done with the control panel.
		</p>

		<form action="index.php" method="post">
			<input name="action" type="hidden" value="secure" />
			<input name="submit" type="submit" value="Secure installer and go to the BBS" />
		</form>
	</div>

</body>
</html>
EOF;
//<?

	exit;
}



// ===================================================================
// No mode specified.  Output installer.
//

// Guess URL for BBS
$url_guess = $_SERVER['SERVER_NAME'].str_replace ('\\', '/', dirname ($_SERVER['PATH_INFO']));

// Test for correct folder permissions
	if (! (is_writable ('resource') && is_writable ('templates'))) {
		// Nope.
echo <<<EOF
	<h2 class="header">
		Installation Error
	</h2>
	<div class="infotable">
		<p>
			&ldquo;templates&rdquo; and &ldquo;resource&rdquo; folders are not writable!  Be sure to CHMOD these folders to their correct permissions before running the installer.
		</p>
	</div>

	</body>
	</html>
EOF;
		exit;
	}


// Begin main install page
echo <<<EOF
	<h1 class="title">
		Wacintaki Poteto Installation
	</h1>

	<hr />


	<h2 class="header">
		Installation Notes
	</h2>

	<div class="infotable">
		<p class="infonote">
			For help with installation, read the &ldquo;readme.html&rdquo; file that came with your Wacintaki distribution.  Make sure you have CHMOD all files appropriately before continuing with installation.  For technical assistance, please visit the <a href="http://www.NineChime.com/forum/">NineChime Software Forum</a>.
		</p>
	</div>
	<br />



	<form name="form1" method="post" action="install.php">
		<h2 class="header">
			$langop_install_information
		</h2>

		<div class="infotable">
			<p class="infonote">
				One MySQL database is required to install Wacintaki.  If you do not know how to access your MySQL account, e-mail your sysadmin, or log into your control panel and look for a database tool such as phpMyAdmin.  On most servers, &ldquo;localhost&rdquo; will work for the hostname, though web hosts with a dedicated MySQL server may require something such as &ldquo;mysql.server.com&rdquo;.  Be aware that some database tools, such as CPanel or phpMyAdmin, may automatically add a prefix to your database name or username, so if you create a database called &ldquo;oekaki&rdquo;, the result may end up being &ldquo;accountname_oekaki&rdquo;.  The OekakiPoteto database prefixes (default &ldquo;op_&rdquo;) are only significant if you wish to install more than one oekaki.
			</p>

			<table class="infomain">
			<tr>
			<td class="infoask" valign="top">
				$langop_install_dbhostname
			</td>
			<td class="infoenter" valign="top">
				<input type="text" name="dbhost" size="40" style="font-color:red;" value="localhost" />
			</td>

			<tr><td colspan="2">&nbsp;</td></tr>


			<tr>
			<td class="infoask" valign="top">
				$langop_install_dbname
			</td>
			<td class="infoenter" valign="top">
				<input type="text" name="dbname" size="40" value="$dbname" />
			</td>
			</tr>

			<tr><td colspan="2">&nbsp;</td></tr>


			<tr>
			<td class="infoask" valign="top">
				$langop_install_dbusername
			</td>
			<td>
				<input type="text" name="dbuser" size="40" value="$dbuser" />
			<td class="infoenter" valign="top">
			</tr>

			<tr><td colspan="2">&nbsp;</td></tr>


			<tr>
			<td class="infoask" valign="top">
				$langop_install_dbpass
			</td>
			<td class="infoenter" valign="top">
				<input type="password" name="dbpass" size="40" />
			</tr>

			<tr><td colspan="2">&nbsp;</td></tr>


			<tr>
			<td class="infoask" valign="top">
				$langop_install_prefix
			</td>
			<td class="infoenter" valign="top">
				<input type="text" name="dbprefix" size="40" value="op_" />

				<p class="subtext">
					$langop_install_prefixsub
				</p>
			</td>
			</tr>

			<tr><td colspan="2">&nbsp;</td></tr>


			<tr>
			<td class="infoask" valign="top">
				$langop_install_mdbprefix
			</td>
			<td class="infoenter" valign="top">
				<input name="OekakiPoteto_MemberPrefix" type="text" id="OekakiPoteto_MemberPrefix" value="op_" size="40" />

				<p class="subtext">
					If you are trying to install multiple boards using one database, make sure all other OP board databases that you want to use under one account have the same prefix, otherwise, leave this value alone.
				</p>
			</td>
			</tr>
			</table>

			<p class="infonote" style="text-align: center">
				Click here to <a href="install.php?mode=del">uninstall an existing database</a>.  Confirmation will be requested.
			</p>
		</div>
		<br />



		<h2 class="header">
			$langop_install_dispreg
		</h2>

		<div class="infotable">
			<table class="infomain">
			<tr>
			<td class="infoask" valign="top">
				$langop_install_opurl
			</td>
			<td class="infoenter" valign="top">
				<input name="op_url" type="text" value="http://{$url_guess}" size="40" />
				<p class="subtext">
					This is a guess.  Make sure it is correct, or registration will not work correctly.
				</p>
			</td>
			</tr>

			<tr><td colspan="2">&nbsp;</td></tr>


			<tr>
			<td class="infoask" valign="top">
				$langop_install_email
			</td>
			<td class="infoenter" valign="top">
				<input name="op_email" type="text" size="40" />

				<p class="subtext">
					$langop_install_emailsub
				</p>
			</td>
			</tr>
			</table>
		</div>
		<br />



		<h2 class="header">
			$langop_install_general
		</h2>

		<div class="infotable">
			<table class="infomain">
			<tr>
			<td class="infoask" valign="top">
				$langop_install_salt
			</td>
			<td class="infoenter" valign="top">
				<input type="text" name="salt" size="40" value="As" />

				<p class="subtext">
					$langop_install_saltsub
				</p>
			</td>
			</tr>

			<tr><td colspan="2">&nbsp;</td></tr>


			<tr>
			<td class="infoask" valign="top">
				Picture Name Prefix
			</td>
			<td class="infoenter" valign="top">
				<input name="op_pre" type="text" value="OP_" size="40" />

				<p class="subtext">
					This prefix will appear on every picture and animation saved by the BBS.  Example: "OP_50.png"
				</p>
			</td>
			</tr>

			<tr><td colspan="2">&nbsp;</td></tr>


			<tr>
			<td class="infoask" valign="top">
				$langop_install_picdir
			</td>
			<td class="infoenter" valign="top">
				<input name="op_pics" type="text" value="pictures" size="40" />

				<p class="subtext">
					$langop_install_picdirsub
				</p>
			</td>
			</tr>

			<tr><td colspan="2">&nbsp;</td></tr>


			<tr>
			<td class="infoask" valign="top">
				$langop_install_picstore
			</td>
			<td class="infoenter" valign="top">
				<input name="pic_store" type="text" value="200" size="40" />

				<p class="subtext">
					$langop_install_picstoresub
				</p>
			</td>
			</tr>

			<tr><td colspan="2">&nbsp;</td></tr>


			<tr>
			<td class="infoask" valign="top">
				Allow Public Pictures
			</td>
			<td class="infoenter" valign="top">
				<select name="public_retouch" class="multiline">
					<option value="yes" selected>$langop_word_yes</option>
					<option value="no">$langop_word_no</option>
				</select>
				<p class="subtext">
					Public pictures may be retouched by any member with draw permissions. No passwords are used, and retouched images are submitted as new posts. <strong>NOTE</strong>: May result in floods without strict rules and administration.
				</p>
			</td>
			</tr>

			<tr><td colspan="2">&nbsp;</td></tr>


			<tr>
			<td class="infoask" valign="top">
				Allow Safety Saves
			</td>
			<td class="infoenter" valign="top">
				<select name="safety_saves" class="multiline">
					<option value="yes" selected>$langop_word_yes</option>
					<option value="no">$langop_word_no</option>
				</select>
				<p class="subtext">
					Safety saves do not show up on the board while they are in progress.  Only one safety save is allowed per member, and they are automatically deleted after a certain number of days
				</p>
			</td>
			</tr>

			<tr><td colspan="2">&nbsp;</td></tr>


			<tr>
			<td class="infoask" valign="top">
				Safety Save Storage
			</td>
			<td class="infoenter" valign="top">
				<input name="safety_storetime" type="text" value="10" size="5" class="txtinput" /> days

				<p class="subtext">
					Number of days safety saves are stored before they are removed.  Default is 10, max is 60
				</p>
			</td>
			</tr>
			</table>
		</div>
		<br />



		<h2 class="header">
			$langop_install_reg
		</h2>

		<div class="infotable">
			<table>
			<tr>
			<td class="infoask" valign="top">
				$langop_install_adel
			</td>
			<td class="infoenter" valign="top">
				<input name="kill_user" type="text" value="-1" size="6" />
				$langop_install_adelsub2

				<p class="subtext">
					$langop_install_adelsub
				</p>
			</td>
			</tr>

			<tr><td colspan="2">&nbsp;</td></tr>


			<tr>
			<td class="infoask" valign="top">
				Auto Immunity for Artists
			</td>
			<td class="infoenter" valign="top">
				<select name="draw_immune" class="multiline">
					<option value="yes" selected>$langop_word_yes</option>
					<option value="no">$langop_word_no</option>
				</select>

				<p class="subtext">
					If yes, people who draw pictures will automatically receive the immunity flag from auto user delete.
				</p>
			</td>
			</tr>

			<tr><td colspan="2">&nbsp;</td></tr>


			<tr>
			<td class="infoask" valign="top">
				Show Rules Before Registration
			</td>
			<td class="infoenter" valign="top">
				<select name="reg_rules" class="multiline">
					<option value="yes">$langop_word_yes</option>
					<option value="no" selected>$langop_word_no</option>
				</select>

				<p class="subtext">
					If yes, people will be shown the rules before they can submit a new registration.  Use &ldquo;Edit Rules&rdquo; in the admin menu to set rules.
				</p>
			</td>
			</tr>

			<tr><td colspan="2">&nbsp;</td></tr>


			<tr>
			<td class="infoask" valign="top">
				$langop_install_gallow
			</td>
			<td class="infoenter" valign="top">
				<select name="guest_post">
					<option value="yes" selected>$langop_word_yes</option>
					<option value="no">$langop_word_no</option>
				</select>

				<p class="subtext">
					$langop_install_gallowsub
				</p>
			</td>
			</tr>

			<tr><td colspan="2">&nbsp;</td></tr>


			<!-- Require Art -->
			<tr>
			<td class="infoask" valign="top">
				Require Art Submission
			</td>
			<td class="infoenter" valign="top">
				<select name="require_art">
					<option value="yes">$langop_word_yes</option>
					<option value="no" selected>$langop_word_no</option>
				</select>

				<p class="subtext">
					If yes, new users are instructed to provide a link to a piece of art for the administrator to view.<br />
					If no, new users are told the URL field is optional.
				</p>
			</td>
			</tr>

			<tr><td colspan="2">&nbsp;</td></tr>


			<tr>
			<td class="infoask" valign="top">
				$langop_install_rapproval
			</td>
			<td class="infoenter" valign="top">
				<select name="approval">
					<option value="yes" selected>$langop_word_yes</option>
					<option value="no">$langop_word_no</option>
					<option value="force">No (forced)</option>
				</select>

				<p class="subtext">
					If yes, approval by the administrators is required to register.<br />
					If no, users will recieve an activation code in their e-mail.
					<b>Use &ldquo;forced&rdquo; ONLY if your server cannot send e-mails, and you want automatic approval.</b>
				</p>
			</td>
			</tr>

			<tr><td colspan="2">&nbsp;</td></tr>


			<tr>
			<td class="infoask" valign="top">
				Default Permissions for Approved Registrations
			</td>
			<td class="infoenter" valign="top">
				<input name="reg_draw" type="checkbox" value="D" checked />Draw Access<br />
				<input name="reg_anim" type="checkbox" value="A" checked />Animation Access<br />
				<input name="reg_upload" type="checkbox" value="U" />Upload Access
			</td>
			</tr>

			<tr><td colspan="2">&nbsp;</td></tr>


			<!-- Self Bump -->
			<tr>
			<td class="infoask" valign="top">
				Members may bump own pictures on retouch?
			</td>
			<td class="infoenter" valign="top">
				<select name="self_bump" class="multiline">
					<option value="yes" selected>$langop_word_yes</option>
					<option value="no">$langop_word_no</option>
				</select>
			</td>
			</tr>
			</table>
		</div>
		<br />



		<h2 class="header">
			$langop_install_dispgen
		</h2>

		<div class="infotable">
			<table class="infomain">

			<!-- BBS Title -->
			<tr>
			<td class="infoask" valign="top">
				$langop_install_title2
			</td>
			<td class="infoenter" valign="top">
				<input name="op_title" type="text" value="OekakiPoteto BBS" size="40" />

				<p class="subtext">
					$langop_install_title2sub
				</p>
			</td>
			</tr>

			<tr><td colspan="2">&nbsp;</td></tr>


			<!-- BBS Author -->
			<tr>
			<td class="infoask" valign="top">
				Author Name
			</td>
			<td class="infoenter" valign="top">
				<input name="op_author" type="text" value="" size="40" />

				<p class="subtext">
					Name of the BBS owner.  This is displayed in the copyright and page metadata.
				</p>
			</td>
			</tr>

			<tr><td colspan="2">&nbsp;</td></tr>


			<tr>
			<td class="infoask" valign="top">
				Adult rated BBS
			</td>
			<td class="infoenter" valign="top">
				<select name="op_adult">
					<option value="yes">Yes</option>
					<option value="no" selected>No</option>
				</select>
				<br />

				<p class="subtext">
					Select Yes to declare your BBS for adults only.  Users are required to state their age to register.<br />
					NOTE:  Does <strong>not</strong> make every picture adult by default.
				</p>
			</td>
			</tr>

			<tr><td colspan="2">&nbsp;</td></tr>


			<tr>
			<td class="infoask" valign="top">
				Allow guests access to pr0n
			</td>
			<td class="infoenter" valign="top">
				<select name="guest_adult" class="multiline">
					<option value="yes" selected>$langop_word_yes</option>
					<option value="no">$langop_word_no</option>
				</select>

				<p class="subtext">
					If yes, adult images are blocked and may be viewed by clicking the pr0n placeholder.<br />
					If no, the link is disabled and all access is blocked.
				</p>
			</td>
			</tr>

			<tr><td colspan="2">&nbsp;</td></tr>


			<tr>
			<td class="infoask" valign="top">
				$langop_install_deftem
			</td>
			<td class="infoenter" valign="top">
				<select name="template" id="template">

EOF;
//<?

if ($handle = opendir('templates')) {
	/* This is the correct way to loop over the directory. */
	while (false !== ($file = readdir($handle))) {
		if (substr($file,-4) == '.php'){
			if (strtolower(substr($file,0,-4)) == 'banana') {
?>
				<option value="<?=substr($file,0,-4)?>" selected><?= substr($file, 0, -4); ?></option>
<?
			} else {
?>
				<option value="<?=substr($file,0,-4)?>"><?= substr($file, 0, -4); ?></option>
<?
			}
		}
	}
	closedir($handle);
}

echo <<<EOF
				</select>

				<p class="subtext">
					$langop_install_deftemsub
				</p>
			</td>
			</tr>

			<tr><td colspan="2">&nbsp;</td></tr>


			<!-- Pictures per index page -->
			<tr>
			<td class="infoask" valign="top">
				Number of Pics on Index
			</td>
			<td class="infoenter" valign="top">
				<input name="pic_pages" type="text" value="10" size="40" />

				<p class="subtext">
					Number of pictures to display per page of the BBS
				</p>
			</td>
			</tr>

			<tr><td colspan="2">&nbsp;</td></tr>


			<!-- Pictures per other page -->
			<tr>
			<td class="infoask" valign="top">
				Number of Entries on Menus
			</td>
			<td class="infoenter" valign="top">
				<input name="menu_pages" type="text" value="25" size="40" />

				<p class="subtext">
					Number of entries (such as user names) to display per page of the menus and admin controls
				</p>
			</td>
			</tr>

			<tr><td colspan="2">&nbsp;</td></tr>


			<!-- Smilies -->
			<tr>
			<td class="infoask" valign="top">
				Use Smilies in Comments?
			</td>
			<td class="infoenter" valign="top">
				<select name="smilies" class="multiline">
					<option value="yes" selected>$langop_word_yes</option>
					<option value="no">$langop_word_no</option>
				</select>
				<p class="subtext">
					Smilies are configurable by editing the &ldquo;hacks.php&rdquo; file
				</p>
			</td>
			</tr>
			</table>
		</div>
		<br />



		<!-- Avatars -->
		<h2 class="header">
			Avatars
		</h2>

		<div class="infotable">
			<table class="infomain">
			<!-- Enable -->
			<tr>
			<td class="infoask" valign="top">
				Enable Avatars
			</td>
			<td class="infoenter" valign="top">
				<select name="use_avatars" class="multiline">
					<option value="yes" selected>$langop_word_yes</option>
					<option value="no">$langop_word_no</option>
				</select>
			</td>
			</tr>

			<tr><td colspan="2">&nbsp;</td></tr>


			<tr>
			<td class="infoask" valign="top">
				Allow Avatars On Comments
			</td>
			<td class="infoenter" valign="top">
				<select name="use_c_avatars" class="multiline">
					<option value="no" selected>$langop_word_no</option>
					<option value="yes">$langop_word_yes</option>
				</select>
			</td>
			</tr>

			<tr><td colspan="2">&nbsp;</td></tr>


			<tr>
			<td class="infoask" valign="top">
				Avatar Storage
			</td>
			<td class="infoenter" valign="top">
				<input name="avatar_folder" type="text" class="textinput" size="60" value="avatars" />

				<p class="subtext">
					Change <strong>only</strong> if installing multiple boards.  Read the manual!<br />
					Basicly, use one folder for all boards.  Example:  use &ldquo;avatars&rdquo; for board 1, &ldquo;../board1/avatars&rdquo; for board 2, etc.
				</p>
			</td>
			</tr>

			<tr><td colspan="2">&nbsp;</td></tr>


			<tr>
			<td class="infoask" valign="top">
				Maximum Avatar Size
			</td>
			<td class="infoenter" valign="top">
				<input name="avatar_x" type="text" value="50" size="6" class="txtinput" />
				&times;
				<input name="avatar_y" type="text" value="50" size="6" class="txtinput" />

				<p class="subtext">
					Default is 50 &times; 50 pixels.  Larger than 60 &times; 60 not recommended
				</p>
			</td>
			</tr>
			</table>
		</div>
		<br />



		<h2 class="header">
			$langop_install_appletset
		</h2>

		<div class="infotable">
			<table class="infomain">
			<!-- Canvas Defaults -->
			<tr>
			<td class="infoask" valign="top">
				Default Canvas Size
			</td>
			<td class="infoenter" valign="top">
				<input name="def_x" type="text" value="300" size="6" />
				&times;
				<input name="def_y" type="text" value="300" size="6" />

				<p class="subtext">
					The default canvas size.  Typical value is 300 &times; 300 pixels
				</p>
			</td>
			</tr>

			<tr><td colspan="2">&nbsp;</td></tr>


			<!-- Canvas Min -->
			<tr>
			<td class="infoask" valign="top">
				Minimum Canvas Size
			</td>
			<td class="infoenter" valign="top">
				<input name="min_x" type="text" value="50" size="6" />
				&times;
				<input name="min_y" type="text" value="50" size="6" />

				<p class="subtext">
					The minimum canvas size.  Recommended minimum is 50 &times; 50 pixels
				</p>
			</td>
			</tr>

			<tr><td colspan="2">&nbsp;</td></tr>


			<!-- Canvas Max -->
			<tr>
			<td class="infoask" valign="top">
				Maximum Canvas Size
			</td>
			<td class="infoenter" valign="top">
				<input name="canvas_x" type="text" value="500" size="6" />
				&times;
				<input name="canvas_y" type="text" value="500" size="6" />

				<p class="subtext">
					Maximum canvas.  Recommended maximum is 500 &times; 500 pixels.<br />
					Be aware that a small increase in dimentions results in a large increase in surface area, and thus filesize and bandwidth.  1000 &times; 1000 uses <strong>four times</strong> as much bandwidth as 500 &times; 500!
				</p>
			</td>
			</tr>

			<tr><td colspan="2">&nbsp;</td></tr>


			<!-- Max Anim -->
			<tr>
			<td class="infoask" valign="top">
				$langop_install_animax
			</td>
			<td class="infoenter" valign="top">
				<input name="max_anim" type="text" value="500000" size="40" />
				$langop_install_bytes

				<p class="subtext">
					$langop_install_animaxsub
				</p>
			</td>
			</tr>

			<tr><td colspan="2">&nbsp;</td></tr>


			<!-- Max Upload -->
			<tr>
			<td class="infoask" valign="top">
				Maximum Upload Filesize
			</td>
			<td class="infoenter" valign="top">
				<input name="max_pic" type="text" value="500000" size="40" class="txtinput" />
				$langop_install_bytes

				<p class="subtext">
					The max filesize uploaded pictures can be, in bytes.  Default is 500,000 bytes or 500KB.<br />
					Maximum is 2,000,000 bytes or 2MB, the maximum value allowed for most servers.
				</p>
			</td>
			</tr>

			<tr><td colspan="2">&nbsp;</td></tr>


			<!-- Max Area
			<tr>
			<td class="infoask" valign="top">
				Maximum Canvas Area
			</td>
			<td class="infoenter" valign="top">
				<input name="canvas_a" type="text" value="250000" size="40" />

				<p class="subtext">
					This setting allows for large, panoramic canvases without affecting bandwidth.  Example: 1000 &times; 250 uses the same bandwidth as 500 &times 500, while allowing the max width and height to be 1000 pixels each.  However, a 1000 &times 1000 canvas would not be allowed.  Default is 250000 pixels.
				</p>
			</td>
			</tr>

			<tr><td colspan="2">&nbsp;</td></tr>
			-->
			<input name="canvas_a" type="hidden" value="250000" />



			<!-- Preview -->
			<tr>
			<td class="infoask" valign="top">
				Canvas size preview
			</td>
			<td class="infoenter" valign="top">
				<input name="preview_img" type="text" value="preview.png" size="40" />

				<p class="subtext">
					Image for canvas size preview on Draw screen.  Square picture recommended.
				</p>
			</td>
			</tr>

			<tr><td colspan="2">&nbsp;</td></tr>


			<!-- Preview Title -->
			<tr>
			<td class="infoask" valign="top">
				Preview Title
			</td>
			<td class="infoenter" valign="top">
				<input name="preview_title" type="text" value="Image Preview" size="40" />

				<p class="subtext">
					Title of preview image (Text only &amp; do not use double quotes).
				</p>
			</td>
			</tr>

			<tr><td colspan="2">&nbsp;</td></tr>


			<!-- Pr0n Image -->
			<tr>
			<td class="infoask" valign="top">
				&ldquo;Pr0n&rdquo; placeholder image
			</td>
			<td class="infoenter" valign="top">
				<input name="porn_img" type="text" value="pr0n.png" size="40" class="txtinput" />

				<p class="subtext">
					Image for substitution of pr0n.  Square picture recommended.  Default &ldquo;pr0n.png&rdquo;
				</p>
			</td>
			</tr>
			</table>
		</div>
		<br />



		<!-- Mailbox -->
		<h2 class="header">
			Display - $langop_word_mailbox
		</h2>

		<div class="infotable">
			<table class="infomain">

			<!-- Enable Mailbox -->
			<tr>
			<td class="infoask" valign="top">
				Enable $langop_word_mailbox
			</td>
			<td class="infoenter" valign="top">
				<select name="use_mailbox" class="txtinput">
					<option value="yes" selected>$langop_word_yes (recommended)</option>
					<option value="no">$langop_word_no</option>
				</select>
			</td>
			</tr>
			</table>
		</div>
		<br />



		<h2 class="header">
			$langop_install_dispchat
		</h2>

		<div class="infotable">
			<table class="infomain">

			<tr>
			<td class="infoask" valign="top">
				Enable Chat
			</td>
			<td class="infoenter" valign="top">
				<select name="use_chat">
					<option value="no" selected>$langop_word_no (recommended)</option>
					<option value="yes">$langop_word_yes</option>
				</select>

				<p class="subtext">
					Note:  chat uses a lot of bandwidth
				</p>
			</td>
			</tr>

			<tr><td colspan="2">&nbsp;</td></tr>

			<tr>
			<td class="infoask" valign="top">
				$langop_install_displinesmax
			</td>
			<td class="infoenter" valign="top">
				<input name="chat_max" type="text" value="1000" size="40" />
			</td>
			</tr>

			<tr><td colspan="2">&nbsp;</td></tr>


			<tr>
			<td class="infoask" valign="top">
				$langop_install_displines
			</td>
			<td class="infoenter" valign="top">
				<input name="chat_pages" type="text" value="15" size="40" />
			</td>
			</tr>
			</table>
		</div>
		<br />



		<!-- Compression Settings -->
		<h2 class="header">
			$langop_compress_title
		</h2>

		<div class="infotable">
			<p class="infonote">

EOF;
if (!extension_loaded ('gd')) {
echo <<<EOF
				Your server does not have the graphics system &ldquo;GDlib&rdquo; installed, therefore you cannot enable thumbnail support.  However, you may still select a default thumbnail mode which will conserve screenspace by shrinking pictures.<br />
				<br />

EOF;
}
echo <<<EOF
				Four thumbnail modes are available.  None, Layout, Scaled, and Uniformity.  If you're confused which mode to use, try Scaled first.<br />
				<br />
				<strong>None</strong> will disable thumbnail/layout support, and will use a lot of bandwidth.  <strong>Layout</strong> will keep pictures their original sizes unless they use too much bandwidth, and then a thumbnail is used.  <strong>Scaled Layout</strong> is identical to Layout except very large pictures are scaled to fit the screen.  <strong>Uniformity</strong> makes all the pictures the same size with a tiny thumbnail.<br />
				<br />
				If you choose &ldquo;None&rdquo;, thumbnail support will always be off for all members unless you enable it later in the control panel.
			</p>

			<table class="infomain">
			<!-- Layout mode -->
			<tr>
			<td class="infoask" valign="top">
				Default thumbnail mode
			</td>
			<td class="infoenter" valign="top">
				<select name="use_thumb" class="multiline">
					<option value="0">None</option>
					<option value="1">Layout</option>
					<option value="2" selected>Scaled (default)</option>
					<option value="3">Uniformity</option>
				</select>

				<p class="subtext">
					Tip:  Options are ordered in terms of bandwidth.  Uniformity uses the least bandwidth.  Scaled Layout is recommended.
				</p>
			</td>
			</tr>


			<tr><td colspan="2">&nbsp;</td></tr>


			<!-- Force Layout -->
			<tr>
			<td class="infoask" valign="top">
				 Force default thumbnails
			</td>
			<td class="infoenter" valign="top">
				<select name="force_thumb" class="multiline">
					<option value="yes" selected>$langop_word_yes</option>
					<option value="no">$langop_word_no</option>
				</select>

				<p class="subtext">
					If yes, users may only use the default mode (recommended for servers with little bandwidth). If no, users may select any thumbnail mode they wish.
				</p>
			</td>
			</tr>


			<tr><td colspan="2">&nbsp;</td></tr>


			<!-- Small Thumbnail Size -->
			<tr>
			<td class="infoask" valign="top">
				Small thumbnail size
			</td>
			<td class="infoenter" valign="top">
				<input name="thumb_t" type="text" value="120" size="10" class="txtinput" />

				<p class="subtext">
					Size of small (uniformity) thumbnails in pixels.  Small thumbnails are generated often.  Default 120.
				</p>
			</td>
			</tr>


			<tr><td colspan="2">&nbsp;</td></tr>


			<!-- Large Thumbnail Size -->
			<tr>
			<td class="infoask" valign="top">
				Large thumbnail size
			</td>
			<td class="infoenter" valign="top">
				<input name="thumb_r" type="text" value="250" size="10" class="txtinput" />

				<p class="subtext">
					Size of large (layout) thumbnails.  Large thumbnails are made only occasionally for layout or scaled thumbnail modes.  Default 250.
				</p>
			</td>
			</tr>


			<tr><td colspan="2">&nbsp;</td></tr>


			<!-- Thumbnail Bytes -->
			<tr>
			<td class="infoask" valign="top">
				Filesize for large thumbnail generation
			</td>
			<td class="infoenter" valign="top">
				<input name="thumb_bytes" type="text" value="100000" size="10" class="txtinput" />
				<?=$langop_install_bytes?> 

				<p class="subtext">
					If a picture's filesize is greater than this value, a large thumbnail will be generated in addition to the small one.  Default is 100,000 bytes.  If using uniformity mode only, set to zero to disable and save server space.
				</p>
			</td>
			</tr>
			</table>
		</div>
		<br />



		<h2 class="header">
			$langop_install_admininfo
		</h2>

		<div class="infotable">
			<p class="infonote">
				<strong>$langop_install_TOS</strong>
			</p>

			<table class="infomain">
			<tr>
			<td class="infoask" valign="top">
				$langop_install_login
			</td>
			<td class="infoenter" valign="top">
				<input type="text" name="usrname" size="40" value="$usrname" />
			</td>
			</tr>


			<tr>
			<td class="infoask" valign="top">
				$langop_install_password
			</td>
			<td class="infoenter" valign="top">
				<input type="password" name="pass" size="40" />
			</td>
			</tr>


			<tr>
			<td class="infoask" valign="top">
				$langop_eprofile_repass
			</td>
			<td class="infoenter" valign="top">
				<input type="password" name="pass2" size="40" />
			</td>
			</tr>


			<tr>
				<td class="infoask" valign="top">
				Your E-mail Address (leave blank to use registration e-mail)
			</td>
			<td class="infoenter" valign="top">
				<input type="text" name="admin_email" size="40" />
			</td>
			</tr>
			</table>
		</div>
		<br />



		<h2 class="header">
			Submit Information for Install
		</h2>

		<div class="infotable">
			<p style="text-align: center;">
				<input type="submit" name="Submit" value="Submit" />
			</p>
		</div>
	</form>
	<br />


	<div id="footer">
		OekakiPoteto 5.x by <a href="http://www.suteki.nu">RanmaGuy</a> and <a href="http://www.cellosoft.com">Marcello</a><br />
		Wacintaki Poteto 1.x modifications by <a href="http://www.NineChime.com/Wacintosh.htm">Waccoon</a>
	</div>

</body>
</html>
EOF;
//<?

exit();

?>